      subroutine map_steel_cctsolve(gbn,v,g, 
     &radius,vm,sv,tprev,tnew,imax,iuse,ifail)
      implicit none
      double precision gbn,v,g,radius,vm,sv,tprev
      double precision limit,t1,t3,fac,f1,f3,t2,f2
      double precision tnew,map_steel_wkinetic
      integer icount,ifail,imax,iuse
      ifail = 0
      if (v .gt. vm) then
          ifail=1
      endif
      if ((v .gt. 1.0d-04).or.(v .gt. vm)) then
* start by bracketing the solution
      if ((v .gt. 0.65) .or. (v .lt. 0.05)) then
           limit=0.025
      else
           limit=0.05
      endif
      icount=0
      t1=0.4*tprev
      t3=4.0*tprev
      fac=2.0
1     f1=map_steel_wkinetic(gbn,t1,g,radius,vm,sv)-v
      f3=map_steel_wkinetic(gbn,t3,g,radius,vm,sv)-v
      icount=icount+1
      if (icount .gt. 40 ) then
         ifail =2
      endif
      if (f3 .lt. 0.0) then
          t3=t3*fac
          goto 1
      endif
      if (f1 .gt. 0.0) then
          t1=t1/fac
          goto 1
      endif
2     t2=0.5d0*(t1+t3)
      icount=icount+1
      if (icount .gt. 40 ) then
         ifail=2                           
      endif
      f2=map_steel_wkinetic(gbn,t2,g,radius,vm,sv)-v
      if (dabs(f2/v) .le. limit) goto 3
      if (f3*f2 .lt. 0) then
          t1=t2
          f1=f2
          goto 2
      else
          f3=f2
          t3=t2
          goto 2
      endif
3     tnew=t2
      else
      tnew=0.0d0
      endif
      end
